## How to Contribute to This Project

### Bug found

-   **Ensure the bug was not already reported** by searching on GitHub under **Issues**.
-   If you're unable to find an open issue addressing the problem, **open a new one**. Be sure to include a **title and clear description**, as much relevant information as possible, and a **code sample** or an **executable test case** demonstrating the expected behavior that is not occurring.

### Submit a patch

-   Open a new GitHub pull request with the patch.
    1.  Fork this project
    2.  Create your feature branch: `git checkout -b my-new-feature`
    3.  Commit your changes: `git commit -am 'Add some feature'`
    4.  Push to the branch: `git push origin my-new-feature`
    5.  Submit a pull request via GitHub's web interface

-   Ensure the PR description clearly describes the problem and its solution. Include the relevant issue number if applicable.

### Request feature

-   Suggest your change as a **new issue** using the label `enhancement` **BEFORE** you start writing code.

### Sponsor Open Source Development

If you need express resolution of a bug or new features you can consider the opportunity of **sponsoring** the relevant development.

-   Open an issue on GitHub (of type `bug` or `enhancement`) with the details of what you want 
-   Contact [example42](https://www.example42.com/) referring the issue you created
-   Tell us how you want to sponsor the development (sending money, gifts or offering services)
-   If we agree on the conditions we will place your company name in the module's Sponsors List

Thanks for contributing! :heart:
